//-----------------------------------------
// ATCutPose -- LScript Genetic
// Noboru Fujiyama 2003/05/27
//                 2003/09/25  add Automaton Model
//  Cut Keys Acs3b/Automaton Local Rotaion -> temp file
//
//  use IKtoRotClient.ls 
//  use temporay dir [Content]/temp/localrot/
//parameter 
//  
@version 2.5
@script generic
@name ATCutPoseZ

@define AUTOMATON_VER 3.0

// BASE Libray select/key/channel
@insert "C:/tools/LWPlugin/NoboUtility/AutomatonZ/src/lscript/ATLib.lsi"

// Matrix Libray
@insert "C:/tools/LWPlugin/NoboUtility/AutomatonZ/src/lscript/ATMatrix.lsi"

/**************************************************************/
/* delete keys*/
/**************************************************************/
s_asItemNames ;
s_asItemId ;

/*************** Item Name Table ********************/
@insert "C:/tools/LWPlugin/NoboUtility/AutomatonZ/src/lscript/MBNameTable.lsi"
/*************** Item Name Table ********************/

generic 
{
	curScene = Scene();
	/* puah seleced item */
	xSelected = curScene.firstSelect();
	if( xSelected == nil)
	{
		error("<br>You must select something before performing this operation." );
		return;		
	}	
	push_selected_item( curScene , xSelected );

	if( 0 == ( nItemType = check_item( s_xParentItem , get_trans_and_rotaion_name() , 14 ) ) )
	{
		error("<br>You must select Automaton character Item ." );
		return;		
	}

	curItem = select_by_name( s_xParentItem , "Master" );
	s_xParentItem = curItem ;
	
	
	fileName = get_temp_filename() ;
	
	if((textFile = File( fileName , "w" ) ) == nil)
	{
		error("Dos not open file ", fileName );
		return;		
	}
	
	/********* save item *********/
	asRotationName = get_rotation_name() ;
	for( i = 1 ; i <= asRotationName.count() ; i++ )
	{
		obj = curItem;
		outputLocalRot( obj , asRotationName[ i ] , curScene.currenttime , textFile ) ;
	}
	asTransAndRotationName = get_trans_and_rotaion_name()  ;
	for( i = 1 ; i <= asTransAndRotationName.count() ; i++ )
	{
		obj = curItem;
		outputLocalTR( obj , asTransAndRotationName[ i ] , curScene.currenttime , textFile ) ;
	}
	for( i = 1 ; i <= s_asFingerRot.count() ; i++ )
	{
		obj = curItem;
		outputLocalRot( obj , s_asFingerRot[ i ] , curScene.currenttime , textFile ) ;
	}

	for( i = 1 ; i <= s_asFingerRot.count() ; i++ )
	{
		obj = curItem;
		outputLocalRot( obj , s_asFingerRot[ i ] , curScene.currenttime , textFile ) ;
	}

	textFile.close() ;

	/* delete key */ 
	s_asItemNames[ 1 ] = " "  + s_xParentItem.name ;
	s_asItemId[ 1 ] = s_xParentItem ;
	search_item_list( s_xParentItem );

	for( nNum = 1 ; nNum <= s_asItemId.size() ; nNum++ )
	{
		xName = parse( " (" , s_asItemId[ nNum ].name ) ;
		if( xName[ 1 ] != "Master" )
		{
			deleteItemChannel( s_asItemId[ nNum ] , curScene.currenttime );
		}
	}	
	/* pop seleced item  */
	pop_selected_item( ) ;
}

/**************************************************************/
/* delete keys*/
/**************************************************************/
search_item_list : xItem 
{
	xMesh = xItem.firstChild();
	while( xMesh )
	{
		//SelectItem( xMesh.id );
		nNum = s_asItemNames.size() + 1 ;
		s_asItemNames[ nNum ] = " "  + xMesh.name ;
		s_asItemId[ nNum ] = xMesh ;
		//CommandInput( "DeleteKey " + time );
		search_item_list( xMesh );
		xMesh = xItem.nextChild();
	}
}
deleteItemChannel: xItem , time  
{
	curChannel = xItem.firstChannel();

	while( nil != curChannel )
	{
		for( nLoop = 1 ; nLoop <=  curChannel.keyCount ; nLoop++ )
		{
			if( time == curChannel.getKeyTime( curChannel.keys[ nLoop ] ) )
			{
				curChannel.deleteKey( curChannel.keys[ nLoop ] );
				break ;
			}
		}
		curChannel = xItem.nextChannel();
	}
}
